import { _decorator, Component, Node, Mask, Vec3, EventTouch, Graphics, UITransform, PhysicsSystem2D, Contact2DType, Collider2D, IPhysics2DContact, selector, ParticleSystem2D } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('ScartchCardOther')
export class ScartchCardOther extends Component {

    @property(Node)
    myMask : Node = null;

    @property(Node)
    public cream_Node : Node = null;

    @property(Node)
    public mainBG : Node = null;

    @property(Node)
    StarParticle : Node = null;

    public size: number = 50;
    public Collider = 0;
    public number = 0;

    onLoad () {
        this.cream_Node.on(Node.EventType.TOUCH_START, this._onTouchBegin, this);
        this.cream_Node.on(Node.EventType.TOUCH_MOVE, this._onTouchMoved, this);
        this.cream_Node.on(Node.EventType.TOUCH_END, this._onTouchEnd, this);
    }

    start(){
    }

    StartButton(){
        this.mainBG.active = false;
    }

    _onTouchBegin (event: EventTouch) {
        this.cream_Node.setWorldPosition(new Vec3(event.getUILocation().x, event.getUILocation().y, 0));
        const point = this._convertToNodeSpace(event);
    }

    _onTouchMoved (event: EventTouch) {
        this.cream_Node.setWorldPosition(new Vec3(event.getUILocation().x, event.getUILocation().y, 0));
        const point = this._convertToNodeSpace(event);
        this._addCircle(point);
        
    }

    _onTouchEnd (event: EventTouch) {
        this.cream_Node.setWorldPosition(new Vec3(event.getUILocation().x, event.getUILocation().y, 0));
        const point = this._convertToNodeSpace(event);
    }

    _convertToNodeSpace(event: EventTouch): Vec3 {
        const location = event.getUILocation();
        return this.myMask.getComponent(UITransform).convertToNodeSpaceAR(new Vec3(location.x, location.y, 0));
    }

    _addCircle (point: Vec3) {
        const stencil = this.myMask.getComponent(Graphics);
        stencil.circle(point.x, point.y, this.size);
        stencil.fill();
    }
}